﻿if select(2, UnitClass('player')) ~= "SHAMAN" then
	return
end
local L = LibStub("AceLocale-3.0"):GetLocale("Yata")
local Yata_TotemTiming = {L["(%d+) min cooldown"], L["(%d+) sec cooldown"]}
local Yata_ToolsTotemRegex = L["Tools_totem_regex"]

function Yata:InitTotems()
	self:GatherTotemData()
	if(#self.TotemData == 0) then 
		self:Print("No totems found, level too low?")
		return false
	end
	return true
end

function Yata:GetTotem(name)
	local result = nil
	for k,v in ipairs(Yata.TotemData) do
		local totem = Yata.TotemData[v]
		totem = totem[#totem]
		if totem.Name == name then		
			result = totem
			break
		end
	end
	return result
end

function Yata:GatherTotemData()
	if self.TotemData then
		table.wipe(self.TotemData)
	end
	
    self.TotemData = {}
    
    local multicastActions = { 133, 134, 135, 136 }
    local totem1, totem2, totem3, totem4, totem5, totem6, totem7 
    local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange 
	local count = 0
	
    for k, actionId in ipairs(multicastActions) do
		totem1, totem2, totem3, totem4, totem5, totem6, totem7 = GetMultiCastTotemSpells(actionId)
		
		local globalIds = { totem1, totem2, totem3, totem4, totem5, totem6, totem7 }
		
		for l, globalId in ipairs(globalIds) do
		    count = count + 1

			name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(globalId)
			
			local totem = {}
			totem.GlobalId = globalId
			totem.Name = name
			totem.Texture = icon
			totem.Mana = cost
			totem.ActionId = actionId
			
			if actionId == 133 then totem.Element = "Fire"; totem.Slot = 1
			elseif actionId == 134 then totem.Element = "Earth"; totem.Slot = 2
			elseif actionId == 135 then totem.Element = "Water"; totem.Slot = 3 
			elseif actionId == 136 then totem.Element = "Air"; totem.Slot = 4
			end
			
			if (not self.TotemData[name]) then
				self.TotemData[name] = {}
				table.insert(self.TotemData, name)
			end

			table.insert(self.TotemData[name],totem)
		end
    end
    
    self.TotemData.Count = count
end
